function love.load()

    sw, sh = love.window.getMode()

    gamestate = {mainmenu = false, gameplay = true, paused = false}

    player = {
        health = 10,
        speed = 1,
        mana = 0,
        pos = {sw/2, sh/2},
        sprite = {
            image = love.graphics.newImage("sprites/bunny-Sheet.png"),
            width = 220,
            height = 444,
            seg_width = 220/4,
            seg_height = 444/6,
            quads = {},
            num = 0,
            scale = 1.75,
            animation = {
                idle_frames = {1,2,3,4,5,6,7,8},
                running_frames = {13,14,9,10,11,12},
                current_frame = 1,
                idle = true,
                dir = "left",
                timer = 0.1
            },
        },
        movement = function(self)
            if love.keyboard.isDown("w") and love.keyboard.isDown("a") then
                if self.pos[1] >= sw / 4 or self.pos[2] >= sh/4 then
                    self.pos[2] = self.pos[2] - (self.speed / math.sqrt(2))
                    self.pos[1] = self.pos[1] - (self.speed / math.sqrt(2))
                    self.sprite.animation.idle = false
                    self.sprite.animation.dir = "left"
                else

                end
            elseif love.keyboard.isDown("w") and love.keyboard.isDown("d") then
                self.pos[2] = self.pos[2] - (self.speed / math.sqrt(2))
                self.pos[1] = self.pos[1] + (self.speed / math.sqrt(2))
                self.sprite.animation.idle = false
                self.sprite.animation.dir = "right"
            elseif love.keyboard.isDown("s") and love.keyboard.isDown("a") then
                self.pos[2] = self.pos[2] + (self.speed / math.sqrt(2))
                self.pos[1] = self.pos[1] - (self.speed / math.sqrt(2))
                self.sprite.animation.idle = false
                self.sprite.animation.dir = "left"
            elseif love.keyboard.isDown("s") and love.keyboard.isDown("d") then
                self.pos[2] = self.pos[2] + (self.speed / math.sqrt(2))
                self.pos[1] = self.pos[1] + (self.speed / math.sqrt(2))
                self.sprite.animation.idle = false
                self.sprite.animation.dir = "right"
            elseif love.keyboard.isDown("w") then
                if self.pos[2] >= sh * (1/2.5) then
                    self.pos[2] = self.pos[2] - player.speed
                    player.sprite.animation.idle = false
                else

                end
            elseif love.keyboard.isDown("s") then
                if self.pos[2] <= sh * (1.5/2.5) then
                    self.pos[2] = self.pos[2] + self.speed
                    self.sprite.animation.idle = false
                else

                end
            elseif love.keyboard.isDown("a") then
                if self.pos[1] >= sw * (1/2.5) then
                    self.pos[1] = self.pos[1] - self.speed
                    self.sprite.animation.idle = false
                    self.sprite.animation.dir = "left"
                else

                end
            elseif love.keyboard.isDown("d") then
                if self.pos[1] <= sw * (1.5/2.5) then
                    self.pos[1] = self.pos[1] + self.speed
                    self.sprite.animation.idle = false
                    self.sprite.animation.dir = "right"
                else

                end
            else
                self.sprite.animation.idle = true
            end
        end,

        animate = function(self, dt)

            if not self.sprite.animation.idle then
                self.sprite.animation.timer = self.sprite.animation.timer + dt
        
                if self.sprite.animation.timer > 0.2 then
                    self.sprite.animation.timer = 0.1
                    self.sprite.animation.current_frame = self.sprite.animation.current_frame + 1
        
                    if self.sprite.animation.current_frame >= #self.sprite.animation.running_frames then
                        self.sprite.animation.current_frame = 1
                    end
                end
            else
                self.sprite.animation.timer = self.sprite.animation.timer + dt
        
                if self.sprite.animation.timer > 0.2 then
                    self.sprite.animation.timer = 0.1
                    self.sprite.animation.current_frame = self.sprite.animation.current_frame + 1
        
                    if self.sprite.animation.current_frame >= #self.sprite.animation.idle_frames then
                        self.sprite.animation.current_frame = 6
                    end
                end
            end  

        end,


        draw = function(self)

            seg_width = self.sprite.seg_width
            seg_height = self.sprite.seg_height
            width, height = self.sprite.width, self.sprite.height
            scale = self.sprite.scale
            x = self.pos[1]
            y = self.pos[2]
            image = self.sprite.image
            quads = self.sprite.quads
            frame = self.sprite.animation.current_frame
            dir = self.sprite.animation.dir

            offset_left = (((width * scale)) + (seg_width))
            offset_right = (seg_width) - (((width * scale)) + (seg_width))
            offset_height = (((height * scale)) + (seg_height))/3
            
            if not self.sprite.animation.idle then
                animation = self.sprite.animation.running_frames
            else
                animation = self.sprite.animation.idle_frames
            end

            if frame > #animation then
                frame = 1
            end

            love.graphics.scale(scale)

            if dir == "left" then
                love.graphics.draw(image, quads[animation[frame]], x, y, 0, 1, 1, offset_left, offset_height)
            else
                love.graphics.draw(image, quads[animation[frame]], x, y, 0, -1, 1, offset_right, offset_height)
            end

            love.graphics.print(math.floor(x))
            love.graphics.print(math.floor(y), 50)

        end
    }

    for j = 1, 6 do 
        for i = 1, 4 do
            player.sprite.num = player.sprite.num + 1
            player.sprite.quads[player.sprite.num] = love.graphics.newQuad(player.sprite.seg_width * (i - 1), player.sprite.seg_height * (j - 1), player.sprite.seg_width, player.sprite.seg_height, player.sprite.width, player.sprite.height)
        end
    end

    menu = {
        color = {.7,.7,.7},
        size = {sw, sh},

        draw = function(self)
            
            r = self.color[1] or 1
            b = self.color[2] or 1
            g = self.color[3] or 1
            button_width = sw/16
            button_height = sh/16

            love.graphics.setBackgroundColor(r,b,g)

            love.graphics.rectangle("fill", sw/2 - button_width/2, sh/2 - button_height/2, button_width, button_height)

        end
    }
end

function love.update(dt)

end

function love.draw()

    if gamestate.mainmenu == true then

        menu:draw()

    elseif gamestate.gameplay == true then
        player:draw()

        love.graphics.circle("line", sw/2, sh/2, 25)
    end

end

function love.mousepressed(x,y,button,isTouch)

    

end